/*
Interactions

`Interactions are managed by our flow designer in UI, what you can control via api is how you start and run interaction flow for contact sending events.  Interaction can start in a multiple ways:  - EntryPont - when contact scans QR code ar opens entry point link  - event as trigger - this way you can start flow for single contact  ## Events Events are a data structure related to some contact action. You can use them whenever you want to start active interaction for contact but also inside interaction flow you can define points wher system should wait for custom event sent from your side.   Depending on your use case our predefined interactions might have defined events and instruction what events should be sent.  Events can be sent directly using our REST Api or triggered automatically by our integration modules.  ## Adding attributes to events Adding attributest to event can personalize communication, select branch flow based on attribute value or use them as perameters in other interaction flow actions. Use `body` property in event structure to add key-value attributes. 

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package interactions

import (
	"encoding/json"
	"fmt"
)

// ExportFormat the model 'ExportFormat'
type ExportFormat string

// List of ExportFormat
const (
	EXPORT_FORMAT_CSV ExportFormat = "csv"
	EXPORT_FORMAT_XLSX ExportFormat = "xlsx"
)

// All allowed values of ExportFormat enum
var AllowedExportFormatEnumValues = []ExportFormat{
	"csv",
	"xlsx",
}

func (v *ExportFormat) UnmarshalJSON(src []byte) error {
	var value string
	err := json.Unmarshal(src, &value)
	if err != nil {
		return err
	}
	enumTypeValue := ExportFormat(value)
	for _, existing := range AllowedExportFormatEnumValues {
		if existing == enumTypeValue {
			*v = enumTypeValue
			return nil
		}
	}

	return fmt.Errorf("%+v is not a valid ExportFormat", value)
}

// NewExportFormatFromValue returns a pointer to a valid ExportFormat
// for the value passed as argument, or an error if the value passed is not allowed by the enum
func NewExportFormatFromValue(v string) (*ExportFormat, error) {
	ev := ExportFormat(v)
	if ev.IsValid() {
		return &ev, nil
	} else {
		return nil, fmt.Errorf("invalid value '%v' for ExportFormat: valid values are %v", v, AllowedExportFormatEnumValues)
	}
}

// IsValid return true if the value is valid for the enum, false otherwise
func (v ExportFormat) IsValid() bool {
	for _, existing := range AllowedExportFormatEnumValues {
		if existing == v {
			return true
		}
	}
	return false
}

// Ptr returns reference to ExportFormat value
func (v ExportFormat) Ptr() *ExportFormat {
	return &v
}

type NullableExportFormat struct {
	value *ExportFormat
	isSet bool
}

func (v NullableExportFormat) Get() *ExportFormat {
	return v.value
}

func (v *NullableExportFormat) Set(val *ExportFormat) {
	v.value = val
	v.isSet = true
}

func (v NullableExportFormat) IsSet() bool {
	return v.isSet
}

func (v *NullableExportFormat) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableExportFormat(val *ExportFormat) *NullableExportFormat {
	return &NullableExportFormat{value: val, isSet: true}
}

func (v NullableExportFormat) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableExportFormat) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}

